DECLARE FUNCTION CheckFileExists% (fileName$)
DECLARE SUB LoadSpriteIntoMap (spriteId%, fileName$, SpriteMap%())
DEFINT A-Z
'$INCLUDE: 'XMASCOM.BI'

SUB CenterText (row%, text$)

    LOCATE row%, 19 - LEN(text$) / 2
    PRINT text$

END SUB

DEFSNG A-Z
FUNCTION CheckFileExists% (fileName$)

    fileExists% = FALSE
    

    IF LTRIM$(RTRIM$(fileName$)) = "" THEN
        EXIT FUNCTION
    END IF

    IF INSTR(fileName$, ".") <= 0 THEN
        fileName$ = LTRIM$(RTRIM$(fileName$)) + ".SDX"
    END IF

    IF LEN(fileName$) > 12 THEN
        EXIT FUNCTION
    END IF


    f% = FREEFILE
    OPEN fileName$ FOR APPEND AS #f%
        IF LOF(f%) THEN
            fileExists% = TRUE
            'LOCATE 2, 2
            'PRINT "File exists check: File exists..."
           
        ELSE
            fileExists% = FALSE
            'LOCATE 3, 2
            'PRINT "File exists check: File does not exist: "; fileName$

        END IF
    CLOSE #f%


   
    ' the above code will create a zero byte file if file does not
    ' previously exist. Delete this temp file before returning.

    IF fileExists% = FALSE THEN
        KILL fileName$
    END IF
  

    CheckFileExists% = fileExists%



END FUNCTION

DEFINT A-Z
SUB ClearKbBuffer
    DEF SEG = &H40
    'POKE &H1C, PEEK(&H1A)
    POKE &H1A, PEEK(&H1C)
    DEF SEG

END SUB

DEFSNG A-Z
SUB EditorExitScreen

    SCREEN 0
    WIDTH 80
    CLS
    COLOR 4, 2
    PRINT "HAPPY "
    COLOR 2, 4
    LOCATE 1, 7
    PRINT " HOLIDAYS!"
    COLOR 15, 0
    PRINT "2021-2022 Nukem Enterprises"
    PRINT "http://eriks.servehttp.com"
    PRINT
    COLOR 7, 0

END SUB

DEFINT A-Z
SUB LoadSpriteIntoMap (spriteId%, fileName$, SpriteMap())

    'Loads file name into sprite data and adds to map.
    'If file does not exist, will load blank (zeros) into
    'sprite data for the id given.


    IF spriteId% < 1 OR spriteId% > MAXSPRITES THEN
        EXIT SUB
    END IF


    REDIM Sprite(MAXSPRITEWIDTH, MAXSPRITEHEIGHT) AS INTEGER


    IF LTRIM$(RTRIM$(fileName$)) <> "" THEN
       
        IF CheckFileExists%(fileName$) = TRUE THEN
                         
                         
            DEF SEG = VARSEG(Sprite(1, 1))
                BLOAD fileName$, VARPTR(Sprite(1, 1))
            DEF SEG


        END IF
    END IF


    FOR y% = 1 TO MAXSPRITEHEIGHT
        FOR x% = 1 TO MAXSPRITEWIDTH
            SpriteMap(spriteId%, x%, y%) = Sprite(x%, y%)
        NEXT x%
    NEXT y%


END SUB

